#ifndef DATAFORWHERECLAUSEAGGREGATION_H_
#define DATAFORWHERECLAUSEAGGREGATION_H_

#pragma once

#include "../DataPage/DataPage.h"

using namespace std;

#include <vector>
#include <string>
#include <map>

class DataForWhereClauseAggregation {
	
	// helper object for "selectFromX" method in QueryManager ..
	
public:

	DataForWhereClauseAggregation();
	~DataForWhereClauseAggregation();
	
	DataPage* getDataPage();
	void setDataPage( DataPage* newDataPage );
	
	vector< vector<string>* >* getQueryPairs();
	void setQueryPairs( vector< vector<string>* >* newQueryPairs );
	
	vector<bool>* getIsPairs();
	void setIsPairs( vector<bool>* newIsPairs );
	
	string getTableNameX();
	void setTableNameX( string newTableNameX );
	
	bool getDoesQueryHaveWhereClause();
	void setDoesQueryHaveWhereClause( bool newDoesQueryHaveWhereClause );
	
	bool getQuerySpecifiesColumnNames();
	void setQuerySpecifiesColumnNames( bool newQuerySpecifiesColumnNames );
	
	map<int, string>* getColumnNames();
	void setColumnNames( map<int, string>* newColumnNames );
	
	int getMaxNumberOfAttributes();
	void setMaxNumberOfAttributes( int newMaxNumberOfAttributes );
	
	map<int, DataPage* >* getReturnPages();
	void setReturnPages( map<int, DataPage* >* newReturnPages );
	
private:

	DataPage* dataPage;
	
	vector< vector<string>* >* queryPairs;
	
	vector<bool>* isPairs;
	
	string tableNameX;
	
	bool doesQueryHaveWhereClause;
	
	bool querySpecifiesColumnNames;
	
	map<int, string>* columnNames;
	
	int maxNumberOfAttributes;
	
	map<int, DataPage* >* returnPages;
	
};

#endif /*DATAFORWHERECLAUSEAGGREGATION_H_*/
