#include "BITSnapShot.h"

BITSnapShot:: BITSnapShot(){
	
	tableNames = new vector<string>();

	pageID = new vector<int>();

	LRUBlocks = new list<int>();
	
	rowAvailable = new vector< vector<bool>* >();
	
}

BITSnapShot:: ~BITSnapShot(){
}


void BITSnapShot:: assignTableNames( vector<string>* newTableNames ){
	
	// "snap shot" of "tableName" for each block in the BP, 
	// reassigned values from "tableName" ..
	
	tableNames->clear();
	
	int tableNamesSize = newTableNames->size();
	
	for(int i=0; i<tableNamesSize; i++){
		
		tableNames->push_back( newTableNames->at(i) );
		
	}
	
	/*
	vector<string>::iterator it_vect;
	
	for(it_vect = newTableNames->begin(); it_vect != newTableNames->end(); it_vect++){
		
		tableNames->push_back( (*it_vect) );
		
	}
	*/
	
} // end "assignPageID( vector<int> newPageID )" ..


void BITSnapShot:: assignPageID( vector<int>* newPageID ){
	
	// "snap shot" of "assignPageID" for each block in the BP, 
	// reassigned values from "newPageID" ..
	
	pageID->clear();
	
	int newPageIDSize = newPageID->size();
	
	for(int i=0; i<newPageIDSize; i++){
		
		pageID->push_back( newPageID->at(i) );
		
	}
	
	/*
	vector<int>::iterator it_vect;
	
	for(it_vect = newPageID->begin(); it_vect != newPageID->end(); it_vect++){
		
		pageID->push_back( (*it_vect) );
		
	}
	*/
	
} // end "assignPageID( vector<int> newPageID )" ..


void BITSnapShot:: assignSlotAvailable( vector< vector<bool>* >* newSlotAvailable ){
	
	// "snap shot" of "slotsAvailable" for each block in the BP, 
	// reassigned values from "newSlotsAvailable" ..
	
	rowAvailable->clear();
	
	int newSlotAvailableSize = newSlotAvailable->size();
	
	for(int i=0; i<newSlotAvailableSize; i++){
		
		rowAvailable->push_back( newSlotAvailable->at(i) );
		
	}
	
	/*
	vector< vector<bool>* >*::iterator it_vect;
	
	for(it_vect = newSlotAvailable->begin(); it_vect != newSlotAvailable->end(); it_vect++){
		
		rowAvailable->push_back( (*it_vect) );
		
	}
	*/
	
} // end "assignSlotAvailable( vector< vector<bool> > slots )" ..


int BITSnapShot:: getBufferInfoTableIndex( string tableName, int pageIDToLocate ){
	
	// DEBUGGING ..
	//cout << "BITSnapShot:: getBufferInfoTableIndex() start .. " << endl << endl;
	
	int bitIndex = -1;
	
	// DEBUGGING ..
	//cout << "BITSnapShot:: bufferPoolSize: " << bufferPoolSize << endl;
	
	for(int i=0; i<bufferPoolSize; i++){
		
		// DEBUGGING ..
		//cout << "BITSnapShot:: pageID["<<i<<"]("<<pageID[i]<<") == pageIDToLocate("<<pageIDToLocate<<"): " << ( pageID[i] == pageIDToLocate ) << endl;
		//cout << "( tableName["<<i<<"]("<<tableName[i]<<").compare( tableName("<<tableName<<") ) == 0 ): " << ( tableName[ i ].compare( tableName ) == 0 ) << endl << endl;
		
		if( ( pageID->at(i) == pageIDToLocate ) &&
		    ( tableNames->at(i).compare( tableName ) == 0 ) ){
			
			// DEBUGGING ..
			//cout << "BITSnapShot:: bitIndex_1: " << bitIndex << endl;
			
			bitIndex = i;
			break;
			
		}
		
	}
	
	// DEBUGGING ..
	//cout << "BITSnapShot:: bitIndex_2: " << bitIndex << endl;
	//cout << "BITSnapShot:: getBufferInfoTableIndex() end .. " << endl << endl;
	
	return bitIndex;
	
}  // end "getBufferInfoTableIndex( int pageID )" ..


	/*
	 * GETTERS ..
	 */ 
	
vector<string>* BITSnapShot:: getTableNames(){
		
	return tableNames;
		
}

int BITSnapShot:: getBufferPoolSize(){
		
	return bufferPoolSize;
		
}
	
vector<int>* BITSnapShot:: getPageIDs(){
		
	return pageID;
		
}
	
list<int>* BITSnapShot:: getLRUBlocks(){
		
	return LRUBlocks;
		
}
	
vector< vector<bool>* >* BITSnapShot:: getRowAvailable(){
		
	return rowAvailable;
		
}
	
	
	/*
	 * SETTERS ..
	 */ 
	

void BITSnapShot:: setTableNames( vector<string>* newTableNames ){
		
	tableNames = newTableNames;
		
}
	
void BITSnapShot:: setBufferPoolSize( int newBufferPoolSize ){
		
	bufferPoolSize = newBufferPoolSize;
		
}
	
void BITSnapShot:: setPageIDs( vector<int>* newPageIDs ){
		
	pageID = newPageIDs;
	
}
	
void BITSnapShot:: setLRUBlocks( list<int>* newLRUBlocks ){
		
	LRUBlocks = newLRUBlocks;
		
}
	
void BITSnapShot:: setRowAvailable( vector< vector<bool>* >* newRowAvailable ){
		
	rowAvailable = newRowAvailable;
		
}
