#ifndef BITSNAPSHOT_H_
#define BITSNAPSHOT_H_

#pragma once

#include <string>
#include <list>
#include <vector>
#include <iostream>

using namespace std;
	
class BITSnapShot{

public:

	BITSnapShot(void);
	~BITSnapShot(void);

	// data members ..
	
	// member methods ..
	
	void assignTableNames( vector<string>* newTableNames );
	
	void assignPageID( vector<int>* newPageID );
	
	void assignSlotAvailable( vector< vector<bool>* >* slots );
	
	int getBufferInfoTableIndex( string tableName, int pageIDToLocate );
	
	
	// getters ..
	
	vector<string>* getTableNames();

	int getBufferPoolSize();
	
	vector<int>* getPageIDs();
	
	list<int>* getLRUBlocks();
	
	vector< vector<bool>* >* getRowAvailable();
	
	
	// setters ..

	void setTableNames( vector<string>* newTableNames );
	
	void setBufferPoolSize( int newBufferPoolSize );
	
	void setPageIDs( vector<int>* newPageIDs );
	
	void setLRUBlocks( list<int>* newLRUBlocks );
	
	void setRowAvailable( vector< vector<bool>* >* newRowAvailable );
	
	
private:

	// data members ..

	vector<string>* tableNames;					// tableName, one per BP block (may not be unique) ..

	int bufferPoolSize;							// snapshot of value "bit.bufferPoolSize" ( retrieved from QM::selectStarFromX() ) ..

	vector<int>* pageID;							// snapshot of values in "bit.pageID" ( retrieved from QM::selectStarFromX() ) ..

	list<int>* LRUBlocks;						// snapshot of values in "bit.LRUBlocks" ( retrieved from QM::selectStarFromX() ) ..
	
	vector< vector<bool>* >* rowAvailable;		// snapshot of values in "bit.rowAvailable" ( retrieved from QM::selectStarFromX() ) ..
	
					   
};

#endif /*BITSNAPSHOT_H_*/