#include "BufferPool.h"


BufferPool:: BufferPool(void){
	
	bufferPoolSize = 0;
	
	dataPages = new vector<DataPage*>();
	
}

BufferPool:: ~BufferPool(void){
}


/*
 * SETTERS ..
 */
 

void BufferPool:: setBufferPoolSize( int bpSize ){
	
	// DEBUGGING ..
	//cout << "BufferPool:: setBufferPoolSize() bpSize: " << bpSize << endl;
	//cout << "BufferPool:: setBufferPoolSize() bufferPoolSize: " << bufferPoolSize << endl;
	
	if ( bufferPoolSize == 0 ){
		
		// initial setting at startup of DBMS ..
		
		if ( bpSize > 0 ){
			
			// DEBUGGING ..
			//cout << "(bpSize > 0): " << (bpSize > 0) << endl;
			
			// size of "dataPage" array matches "dpSize" ..
			for(int i=0; i<bpSize; i++){
				
				dataPages->push_back( new DataPage() );

			}
			
			
		} else {
			
			
			// DEBUGGING ..
			//cout << "(bpSize <= 0): " << (bpSize <= 0) << endl;
			
			// default size of "dataPage" array set to "1" ..
			dataPages->push_back( new DataPage() );
			
		}
		
		bufferPoolSize = bpSize;
	
	} 
	
	else {
		
		// do nothing (cannot change BP size except at beginning of program) ..
		
	}
	
}

void BufferPool:: setDataPages( vector<DataPage*>* newDataPages ){
	
	dataPages = newDataPages;
	
}


/*
 * GETTERS ..
 */


int BufferPool:: getBufferPoolSize(){
	
	return bufferPoolSize;
	
}

vector<DataPage*>* BufferPool:: getDataPages(){
	
	return dataPages;
	
}
