#ifndef CATALOGFILE_H_
#define CATALOGFILE_H_

#pragma once

#include <iostream>
#include <string>

using namespace std;

class CatalogFile {
	
public:

	// data members:
	
	// member functions:
	
	CatalogFile();
	CatalogFile( string newFileDrive, string newFileDirectory, string newFileName, string newFileExtension );


/*
 * SETTERS ..
 */
 
	 void setFileDrive( string fileDrive_ );
	 
	 void setFileDirectory( string fileDirectory_ );
	 
	 void setFileName( string fileName_ );
	 
	 void setFileExtension( string fileExtension_ );	
 
/*
 * GETTERS ..
 */
 
	 string getFileDrive();
	 
	 string getFileDirectory();
	 
	 string getFileName();
	 
	 string getFileExtension();
	 
	 string getFullyQualifiedFileName();


private:

// data members ..

	string fileDrive;								// (i.e.: "C:\\") drive that the DB file resides on ..
	
	string fileDirectory;							// (i.e.: "Temp\\") directory that the DB file resides in ..
	
	string fileName;								// (i.e.: "catalog") name of the DB file ..
	
	string fileExtension;							// (i.e.: ".bin") file type extension for the DB file ..
	
	string fullyQualifiedFileName;					// "fileDrive + fileDirectory + fileName + fileExtension"

// member functions ..

	void updateFullyQualifiedFileName();			// update the "fullyQualifiedFileName" whenever one of the file name parts is changed ..
	

}; // end "File" class ..

#endif /*CATALOGFILE_H_*/
