#ifndef CATALOGINDEX_H_
#define CATALOGINDEX_H_

#pragma once

using namespace std;

#include <iostream>
#include <string>

#include "CatalogIndexAttribute.h"

class CatalogIndex {
	
public:

	CatalogIndex();
	~CatalogIndex();

	
	/*
	 * SETTERS ..
	 */
	 
	void setIndexName( string indexName_ );
	 
	void setIndexTableName( string indexTableName_ );
	
	void setIndexSize( int indexSize_ );
	
	void setIsNoDuplicates( bool isNoDuplicates_ );
	
	void setAttribute( CatalogIndexAttribute* catalogIndexAttribute_ );
	
	void setAttribute( string catalogIndexAttribute_ );
	
	/*
	 * GETTERS ..
	 */
	 
	string getIndexName();
	 
	string getIndexTableName();
	
	int getIndexSize();
	
	bool getIsNoDuplicates();

	CatalogIndexAttribute* getAttribute();

private:

	// data members:

	string indexName;									// this index must be UNIQUE from all other indexName ..
	
	string indexTableName;								// this table must be UNIQUE from all other tableName ..

	int indexSize;										// size in bytes of this index ..

	bool isNoDuplicates;

	CatalogIndexAttribute* catalogIndexAttribute;	    // attribute for this index ..
	
	// member functions:

};

#endif /*CATALOGINDEX_H_*/
