#include "CatalogTable.h"

CatalogTable:: CatalogTable(){
	
	//cout << "CatalogTable() start .." << endl << endl;
	
	// default constructor ..
		
	tableName = "";
	
	tableSize = 0;
	
	numberOfAttributes = 0;
	
	catalogTableAttributes = new vector<CatalogTableAttribute*>();
	
} // end "CatalogTable()" ..


void CatalogTable:: addAttribute( string attributeName ){
	
	//cout << "CatalogTable:: addAttribute() attributeName: " << attributeName << endl << endl;
	
	CatalogTableAttribute* catalogTableAttribute = new CatalogTableAttribute( attributeName );
	
	catalogTableAttributes->push_back( catalogTableAttribute );
	
	numberOfAttributes++;
	
} // end "addAttributeName( string attributeName )" ..


void CatalogTable:: addAttribute( CatalogTableAttribute* catalogTableAttribute ){
	
	catalogTableAttributes->push_back( catalogTableAttribute );
	
	numberOfAttributes++;

} // end "addAttributeName( string attributeName )" ..


void CatalogTable:: removeAttribute( string attributeName ){
	
	CatalogTableAttribute* catalogTableAttribute = NULL;
	
	int catalogTableAttributesSize = catalogTableAttributes->size();
	
	//vector<CatalogTableAttribute>::iterator it;
	
	//for( it = catalogTableAttributes->begin(); it != catalogTableAttributes->end(); it++){
	for(int i=0; i<catalogTableAttributesSize; i++){
		
		catalogTableAttribute = catalogTableAttributes->at(i);
		
		// if you find the "attributeName" to remove, remove it and stop looking ..
		//if ( (*it)->getTableAttributeName().compare( attributeName ) == 0 ){
		if ( catalogTableAttribute->getTableAttributeName().compare( attributeName ) == 0 ){
			
			//catalogTableAttributes.remove( (*it) );
			
			//catalogTableAttributes->erase( it );
			catalogTableAttributes->erase( catalogTableAttributes->begin() + i );
			
			numberOfAttributes--;
			
			break;
			
		}
		
	}
	
	
} // end "removeAttribute( string attributeName )" ..


/*
 * SETTERS ..
 */

void CatalogTable:: setTableName( string tableName_ ){
	
	tableName = tableName_;
	
}

void CatalogTable:: setTableSize( int tableSize_ ){
	
	tableSize = tableSize_;
	
}

void CatalogTable:: setNumberOfAttributes( int numberOfAttributes_ ){
	
	numberOfAttributes = numberOfAttributes_;
	
}

void CatalogTable:: setAttributes( vector<CatalogTableAttribute*>* catalogTableAttributes_ ){
	
	catalogTableAttributes = catalogTableAttributes_;
	
}

/*
 * GETTERS ..
 */


string CatalogTable:: getTableName(){
	
	return tableName;
	
}

int CatalogTable:: getTableSize(){
	
	return tableSize;
	
}

int CatalogTable:: getNumberOfAttributes(){
	
	return numberOfAttributes;
	
}

vector<CatalogTableAttribute*>* CatalogTable:: getAttributes(){
	
	// DEBUGGING ..
	//int ctaSize = catalogTableAttributes->size();
	//for(int i=0; i<ctaSize; i++){
		
	//	cout << "CatalogTable:: getAttributes() catalogTableAttributes->at(i("<<i<<")): " << catalogTableAttributes->at(i)->getTableAttributeName() << endl << endl;
		
	//}
	
	return catalogTableAttributes;
	
}
