#ifndef CATALOGTABLE_H_
#define CATALOGTABLE_H_

#pragma once

#include <iostream>
#include <string>
#include <vector>

#include "CatalogTableAttribute.h"

using namespace std;

class CatalogTable {
	
public:

	// data members:
	
	
	// member functions:
	
	CatalogTable();
	
	void addAttribute( string attributeName );
	
	void addAttribute( CatalogTableAttribute* catalogTableAttribute );
	
	void removeAttribute( string attributeName );
	
	/*
	 * SETTERS ..
	 */
	 
	void setTableName( string tableName_ );
	 
	void setTableSize( int tableSize_ );
	 
	void setNumberOfAttributes( int numberOfAttributes_ );
	 
	void setAttributes( vector<CatalogTableAttribute*>* catalogTableAttributes_ );
	
	/*
	 * GETTERS ..
	 */
	 
	string getTableName();
	 
	int getTableSize();
	 
	int getNumberOfAttributes();
	 
	vector<CatalogTableAttribute*>* getAttributes();


private:

	// data members:
	
	string tableName;								// this table must be UNIQUE from all other tableName ..
	
	int tableSize;									// size in bytes of this table ..
	
	int numberOfAttributes;
	
	vector<CatalogTableAttribute*>* catalogTableAttributes;	// list of attribute for this table ..
	
	// member functions:
	
	
}; // end "CatalogTable" class ..

#endif /*CATALOGTABLE_H_*/