#include "DataHeader.h"

DataHeader:: DataHeader(void) {
	
	headerEntries = new vector<DataHeaderEntry*>();
	
}

DataHeader:: ~DataHeader(void) {
}

int DataHeader:: computeMaxRowCount( int fieldCount_ ){
	
	// "N" : max number of rows (for this pageID) ..
	// "F" : number of fields (for this pageID) ..
	// "i" : size of an "int" variable, in bytes ( i = 4 bytes ) ..
	// "B" : size of a page, in bytes ( B = 48 bytes ) ..
	//  B - ( i * N * F ) = 0
	//          ( N * F ) = ( B / i )
	// 48 - ( 4 * N * F ) = 0
	//          ( N * F ) = 48 / 4 = 12
	//                  N = ( B / i ) / F
	//                  N = 12 / F
	
	int fieldCount = fieldCount_;
	
	// "B" ..
	int numberOfBytesPerBlock = 48;
	
	// "i" ..
	int intSize = 4;
	
	// "( B / i )" ..
	int maxRowsPossiblePerBlock = ( numberOfBytesPerBlock / intSize );
	
	// "N = ( B / i ) / F" ..
	int maxRowCount = -1;
	
	//if ( filePageFieldCount > 0 ) {
	if ( fieldCount > 0 ) {
		
		//maxRowCount = ( maxRowsPossiblePerBlock / filePageFieldCount );
		maxRowCount = ( maxRowsPossiblePerBlock / fieldCount );
		
	}
	
	// F = 1, N = 12
	// F = 2, N = 6
	// F = 3, N = 4
	// F = 4, N = 3
	// F = 5, N = 2.4 [2]*
	// F = 6, N = 2
	// F = 7, N = 1.714285 [1]*
	// F = 8, N = 1.5 [1]*
	
	// * : division operator should round these down to the nearest whole number shown ..
	
	return maxRowCount;
	
	
} // end "computeMaxRowCount( int blockIndex )" ..


/*
 * SETTERS .. 
 */
 
/*
void DataHeader:: setFilePageFieldCount( int newFilePageFieldCount ){
	
	filePageFieldCount = newFilePageFieldCount;
	
}
*/
	
void DataHeader:: setTotalNumberOfDataPages( int newTotalNumberOfDataPages ){
	
	totalNumberOfDataPages = newTotalNumberOfDataPages;
	
}

	
void DataHeader:: setHeaderEntries( vector<DataHeaderEntry*>* newHeaderEntries ){
	
	headerEntries = newHeaderEntries;
	
}
	
	
/*
 * GETTERS .. 
 */
 
/*
int DataHeader:: getFilePageFieldCount(){
	
	return filePageFieldCount;
	
}
*/
	
int DataHeader:: getTotalNumberOfDataPages(){
	
	return totalNumberOfDataPages;
	
}

	
vector<DataHeaderEntry*>* DataHeader:: getHeaderEntries(){
	
	return headerEntries;
	
}
