#include "DataHeaderEntry.h"

DataHeaderEntry:: DataHeaderEntry( int maxRowCount ) {
	
	
	freeRowsCount = maxRowCount;			// start with all rows "free" ..
	
	lockNumber = 0;							// every DataHeaderEntry starts out in "unlocked" state ..
	
	filledRowsCount = 0;					// start with zero data rows (all "filler" string rows) ..

	rowAvailable = new vector<bool>();

	for(int i=0; i < maxRowCount; i++)
		rowAvailable->push_back( true );		// start with all rows "free" ..


}

DataHeaderEntry:: ~DataHeaderEntry(void) {
}

/*
 * SETTERS ..
 */
	
void DataHeaderEntry:: setPageID( int newPageID ){
	
	pageID = newPageID;
	
}
	
	
void DataHeaderEntry:: setFreeRowsCount( int newFreeRowsCount ){
	
	freeRowsCount = newFreeRowsCount;
	
}

	
void DataHeaderEntry:: setLockNumber( int newLockNumber ){
	
	lockNumber = newLockNumber;
	
}

	
void DataHeaderEntry:: setFilledRowsCount( int newFilePageRowCount ){
	
	filledRowsCount = newFilePageRowCount;
	
}

	
void DataHeaderEntry:: setRowAvailable( vector<bool>* newRowAvailable ){
	
	rowAvailable = newRowAvailable;
	
}
	
	
/*
 * GETTERS ..
 */
	
int DataHeaderEntry:: getPageID(){
	
	return pageID;
	
}

	
int DataHeaderEntry:: getFreeRowsCount(){
	
	return freeRowsCount;
	
}

	
int DataHeaderEntry:: getLockNumber(){
	
	return lockNumber;
	
}

	
int DataHeaderEntry:: getFilledRowsCount(){
	
	return filledRowsCount;
	
}

	
vector<bool>* DataHeaderEntry:: getRowAvailable(){
	
	return rowAvailable;
	
}
