#ifndef INDEXBUCKET_H_
#define INDEXBUCKET_H_

using namespace std;

#include <vector>


class IndexBucket {
	
public:

	IndexBucket();
	~IndexBucket();
	
/*
 * GETTERS ..
 */
 
 	vector<int>* getPageIDs();
 
 /*
 * SETTERS ..
 */
 
 	void setPageIDs( vector<int>* pageIDs_ );
 	
	
private:
	
	// NOTE: each "IndexBucket" is pointed to by a single "leaf IndexPage" and
	// each "IndexBucket" points to 1 (if no duplicates) or more (if duplicates) DataPages
	// that contain values associated with its index.
	
	// NOTE: if there are 12 duplicate values for this IndexBucket (pageIDs is full), 
	//       1) create a new "IndexBucket"
	//		 2) place "B12" from the original IndexBucket into the B0 slot of the new "IndexBucket"
	//			("B11" is the max, so "B12" would be 1 more than the max) ..
	//		 3) CHANGED: use a header instead to track each IndexBucket
	//          such that B11 is used for pageID, instead of pointer to next bucket!
	
	// NOTE: 4b int values * 12 pointers = 48 bytes ..
	
	// ===============================================================
	// | B0 | B1 | B2 | B3 | B4 | B5 | B6 | B7 | B8 | B9 | B10 | B11 |
	// ===============================================================
	
	vector<int>* pageIDs;	// represents pageIDs for "DataPages" ..
	
};

#endif /*INDEXBUCKET_H_*/
