#ifndef INDEXBUCKETHEADER_H_
#define INDEXBUCKETHEADER_H_

using namespace std;

#include <map>

#include "IndexBucketHeaderEntry.h"


class IndexBucketHeader {
	
public:

	IndexBucketHeader();
	~IndexBucketHeader();
	
/*
 * HELPERS .. 
 */
	
	bool hasSearchKey( int searchKey_ );
	
	void addBucketIDsForOneSearchKey( int searchKey_, vector<int>* indexBucketIDsForOneSearchKey_ );
	
	void replaceBucketIDsForOneSearchKey( int searchKey_, vector<int>* indexBucketIDsForOneSearchKey_ );
	
	void removeBucketIDsForOneSearchKey( int searchKey_ );
	
/*
 * GETTERS .. 
 */
	
	int getTotalNumberBuckets();
	
	map<int, vector<int>* >* getBucketIDsForEachSearchKey();
	
	int getNumberOfBucketsForOneSearchKey( int searchKey_ );
	
	vector<int>* getBucketIDsForOneSearchKey( int searchKey_ );
	
	vector<IndexBucketHeaderEntry*>* getHeaderEntries();
	
	
/*
 * SETTERS .. 
 */
	
	void setTotalNumberBuckets( int totalNumberBuckets_ );
	
	void setBucketIDsForEachSearchKey( map<int, vector<int>* >* indexBucketIDsForEachSearchKey_ );
	
	void setBucketIDsForOneSearchKey( int searchKey_, vector<int>* indexBucketIDsForOneSearchKey_ );
	
	void setHeaderEntries( vector<IndexBucketHeaderEntry*>* headerEntries_ );
	
private:

	int _totalNumberOfBuckets;									// number of Buckets for all search keys ..

	map<int, vector<int>* >* _indexBucketIDsForEachSearchKey;	// "bucketID"s in the file, for each searchKey ..

	vector<IndexBucketHeaderEntry*>* _headerEntries; 			// tracks each IndexBucket of the Index, one entry per IndexBucket ..
	
};

#endif /*INDEXBUCKETHEADER_H_*/
