#ifndef INDEXHEADER_H_
#define INDEXHEADER_H_

#pragma once

using namespace std;

#include <vector>

#include "IndexHeaderEntry.h"


class IndexHeader {
	
public:

	IndexHeader();
	~IndexHeader();
	
	/*
	 * GETTERS .. 
	 */
	
	int getRootPageID();
	
	int getTotalNumberOfIndexPages();
	
	bool getIsDuplicatesAllowed();
	
	vector<IndexHeaderEntry*>* getHeaderEntries();
	
	
	/*
	 * SETTERS .. 
	 */
	
	void setRootPageID( int rootPageID_ );
	
	void setTotalNumberOfIndexPages( int totalNumberOfIndexPages_ );
	
	void setIsDuplicatesAllowed( bool isDuplicatesAllowed_ );
	
	void setHeaderEntries( vector<IndexHeaderEntry*>* headerEntries_ );
	
	
private:

	int rootPageID;								// pageID of the root node ..
 
	int totalNumberOfIndexPages;				// the total number of "IndexPages" in the file ..

	bool isDuplicatesAllowed;					// whether or not the index has duplicates (buckets) ..

	vector<IndexHeaderEntry*>* headerEntries; 	// tracks each IndexPage of the Index, one entry per IndexPage ..

};

#endif /*INDEXHEADER_H_*/
