#include "IndexNodeRow.h"

IndexNodeRow:: IndexNodeRow(){
	
	_row = new vector<IndexNode*>();
	
}

IndexNodeRow::~ IndexNodeRow(){
	
	delete _row;
	
}

vector<IndexNode*>* IndexNodeRow:: getRow(){
	
	return _row;
	
}

void IndexNodeRow:: setRow( vector<IndexNode*>* row_ ){
	
	_row = row_;
	
}


int IndexNodeRow:: findParentPageID( int currentPageID_ ){
	
	int parentID = -1;
	bool parentIDFound = false;
	
	IndexNode* indexNode = NULL;
	vector<int>* childPageIDs = NULL;
	
	// iterate through the nodes of this parent row ..
	for(int i=0; i<_row->size(); i++){
		
		indexNode = _row->at(i);
		
		childPageIDs = indexNode->getChildIndexPageIDs();
		
		// iterate through the "childPageIDs" of this parent node ..
		for(int j=0; j<childPageIDs->size(); j++){
			
			// if this parent node has a child that matches
			// the current pageID, then parent node is found ..
			if( childPageIDs->at(i) ==  currentPageID_ ){
				
				parentID = indexNode->getIndexPageID();
				parentIDFound = true;
				break;
				
			}
			
		} // end "for()" ..

		if ( parentIDFound == true )
			break;
		
	} // end "for()" ..
	
	return parentID;
	
	
} // end "findParentPageID()" ..


IndexNode* IndexNodeRow:: getIndexNode( int pageID_ ){
	
	bool indexNodeFound = false;
	
	int position = -1;
	
	for( int i=0; i<_row->size(); i++ ){
		
		if( _row->at( i )->getIndexPageID() == pageID_ ){
			
			position = i;
			indexNodeFound = true;
			
		}
		
	}
	
	if( indexNodeFound == true ){
		
		return _row->at( position );
		
	}
	
	return NULL;
	
} // end "getIndexNode()" ..


void IndexNodeRow:: addIndexNode( IndexNode* indexNode_ ){
	
	_row->push_back( indexNode_ );
	
}

