#ifndef INDEXPAGE_H_
#define INDEXPAGE_H_

#pragma once

using namespace std;

#include <vector>


class IndexPage {
	
public:

	IndexPage();
	~IndexPage();
	
	int getChildPageID( int searchKey_ );
	
	/*
	 * GETTERS .. 
	 */
	 
	vector<int>* getSearchKeys();
	
	vector<int>* getChildPageIDs();
	
	bool getIsLeafNode();
	
	int getPageID();


	/*
	 * SETTERS .. 
	 */
	
	void setSearchKeys( vector<int>* searchKeys_ );
	
	void setChildPageIDs( vector<int>* childPageIDs_ );
	
	void setIsLeafNode( bool isLeafNode_ );
	
	void setPageID( int pageID_ );
	
	
private:

 	// ----------------------------------------------------------------
	// |(ptr1)| key1 |(ptr2)| key2 |(ptr3)| key3 |(ptr4)| key4 |(ptr5)|
	// |  P0  |  K0  |  P1  |  K1  |  P2  |  K2  |  P3  |  K4  |  P5  |
 	// ----------------------------------------------------------------

	// format: "collection of all the pages in the index" < "individual index page" > ..
	
	vector<int>* searchKeys;		// search keys (K) for each B+ Tree node ..
	
	vector<int>* childPageIDs;		// pointers to children (P) for each B+ Tree node ..
									// NOTE: leaf pages point to "pointer buckets" ..
	
	bool isLeafNode;				// "true" if the page is a leaf node, "false" otherwise ..

	int pageID;						// this value is not written to or read from file, 
									// but rather used for writing the indexPage, and
									// filled after reading the indexPage ..
	
};

#endif /*INDEXPAGE_H_*/
