#include "IndexRows.h"

IndexRows:: IndexRows(){
	
	_rows = new vector<IndexNodeRow*>();
	
}

IndexRows:: ~IndexRows(){
	
	delete _rows;
	
}

IndexNodeRow* IndexRows:: getRow( int rowNumber_ ){
	
	if( ( rowNumber_ >= 0 ) && ( _rows != NULL ) )
		return _rows->at( rowNumber_ );
	else
		return NULL;
	
}

void IndexRows:: addRow( IndexNodeRow* newRow_ ){
	
	_rows->push_back( newRow_ );
	
}

int IndexRows:: findParentPageID( int currentPageID_, int currentRowNumber_ ){
	
	int parentID = -1;
	
	int parentRowNumber = ( currentRowNumber_ - 1 );
	
	// root node: rowNumber = 0 is min,
	// pageID min is 0 ..
	if( ( parentRowNumber < 0 ) || ( currentPageID_ < 0 ) )
		return parentID;
	
	// get the parent row of the current row ..
	IndexNodeRow* indexNodeRow = _rows->at( parentRowNumber );
	
	parentID = indexNodeRow->findParentPageID( currentPageID_ );
	
	return parentID;
	
	
} // end "findParentPageID()" ..
