#include "TableFormatter.h"

TableFormatter:: TableFormatter() {
	
	assertionsOn = false;
	
	errorString = "";
	
	errorFlag = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	headerColumnSpacer = "  ";
	headerColumnSpacerLeft = "";
	headerColumnSpacerRight = "";
	hasExternalHeaderSpacerLeft = false;
	hasExternalHeaderSpacerRight = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	dividerColumnSpacer = "||";
	dividerColumnSpacerLeft = "";
	dividerColumnSpacerRight = "";
	hasExternalDividerSpacerLeft = false;
	hasExternalDividerSpacerRight = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	dataColumnSpacer = "  ";
	dataColumnSpacerLeft = "";
	dataColumnSpacerRight = "";
	hasExternalDataSpacerLeft = false;
	hasExternalDataSpacerRight = false;
	
	dividerChar = '=';
	
	isHeaderPopulated = false;
	
	isDataPopulated = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	defaultFieldValue = "*";
	
	maxNumberOfHeaderColumns = -1;
	
	maxNumberOfDataColumns = -1;
	
	isTableFormatted = false;
	
} // end "TableFormatter()" ..


void TableFormatter:: resetValues() {
	
	assertionsOn = false;
	
	errorString = "";
	
	errorFlag = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	headerColumnSpacer = "  ";
	headerColumnSpacerLeft = "";
	headerColumnSpacerRight = "";
	hasExternalHeaderSpacerLeft = false;
	hasExternalHeaderSpacerRight = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	dividerColumnSpacer = "||";
	dividerColumnSpacerLeft = "";
	dividerColumnSpacerRight = "";
	hasExternalDividerSpacerLeft = false;
	hasExternalDividerSpacerRight = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	dataColumnSpacer = "  ";
	dataColumnSpacerLeft = "";
	dataColumnSpacerRight = "";
	hasExternalDataSpacerLeft = false;
	hasExternalDataSpacerRight = false;
	
	dividerChar = '=';
	
	defaultFieldValue = "*";
	
	maxNumberOfHeaderColumns = -1;
	
	maxNumberOfDataColumns = -1;
	
	isTableFormatted = false;
	
	isHeaderPopulated = false;
	
	isDataPopulated = false;
	
	headerSizes.clear();
	
	dataSizes.clear();
	
	maxColumnSizes.clear();
	
	columnHeaders.clear();
	
	columnData.clear();
	
	defaultFieldValues.clear();
	
} // end "resetValues()" ..


void TableFormatter:: resetHeaders() {
	
	errorString = "";
	
	errorFlag = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	headerColumnSpacer = "  ";
	headerColumnSpacerLeft = "";
	headerColumnSpacerRight = "";
	hasExternalHeaderSpacerLeft = false;
	hasExternalHeaderSpacerRight = false;
	
	maxNumberOfHeaderColumns = -1;
	
	isTableFormatted = false;
	
	isHeaderPopulated = false;
	
	headerSizes.clear();
	
	maxColumnSizes.clear();
	
	columnHeaders.clear();

	
} // end "resetHeaders()" ..


void TableFormatter:: resetData() {
	
	errorString = "";
	
	errorFlag = false;
	
	// put something here as a default 
	// (user can change this) via method ..
	dataColumnSpacer = "  ";
	dataColumnSpacerLeft = "";
	dataColumnSpacerRight = "";
	hasExternalDataSpacerLeft = false;
	hasExternalDataSpacerRight = false;
	
	maxNumberOfDataColumns = -1;
	
	isTableFormatted = false;
	
	isDataPopulated = false;
	
	dataSizes.clear();
	
	maxColumnSizes.clear();
	
	columnData.clear();
	
} // end "resetData()" ..


void TableFormatter:: resetHeaderSpacers(){
	
	// put something here as a default 
	// (user can change this) via method ..
	headerColumnSpacer = "  ";
	headerColumnSpacerLeft = "";
	headerColumnSpacerRight = "";
	hasExternalHeaderSpacerLeft = false;
	hasExternalHeaderSpacerRight = false;
	
} // end "resetData()" ..


void TableFormatter:: resetDividerSpacers(){
	
	// put something here as a default 
	// (user can change this) via method ..
	dividerColumnSpacer = "  ";
	dividerColumnSpacerLeft = "";
	dividerColumnSpacerRight = "";
	hasExternalDividerSpacerLeft = false;
	hasExternalDividerSpacerRight = false;
	
} // end "resetData()" ..


void TableFormatter:: resetDataSpacers(){
	
	// put something here as a default 
	// (user can change this) via method ..
	dataColumnSpacer = "  ";
	dataColumnSpacerLeft = "";
	dataColumnSpacerRight = "";
	hasExternalDataSpacerLeft = false;
	hasExternalDataSpacerRight = false;	
	
} // end "resetData()" ..


bool TableFormatter:: addColumnHeader( string newHeader ){
	
	if ( newHeader.size() > 0 ) {
		
		columnHeaders.push_back( newHeader );
		
		// if "formatTable()" was called prior to this method,
		// the old formatting is invalid now that a new value
		// has been added ..
		if ( isTableFormatted == true )
			isTableFormatted = false;
		
	}
	 
} // end "addColumnHeader()" ..


bool TableFormatter:: addColumnData( int columnNumber, string newColumnData ){
	
	columnDataRow.insert( pair<int,string>( columnNumber, newColumnData ) );
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been added ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
	
} // end "addColumnData()" ..


bool TableFormatter:: addDefaultValue( int columnNumber, string newDefaultValue ){
	
	defaultFieldValues.insert( pair<int,string>( columnNumber, newDefaultValue ) );
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been added ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
	
} // end "addDefaultValue()" ..


bool TableFormatter:: endDataRow(){
	
	// must use this after entering data for a row via "addColumnData()" method,
	// but don't use this with / not needed for either "addColumnHeader()" or "addDefaultValue()" ..
	if ( columnDataRow.size() > 0 ) {
	
		columnData.push_back( columnDataRow );
	
		columnDataRow.clear();
		
	}
	
} // end "endColumnDataRow()" ..


	/*
	 * SETTERS ..
	 */
	
	
void TableFormatter:: setHeaderColumnSpacer( string newHeaderColumnSpacer ){
		
	headerColumnSpacer = newHeaderColumnSpacer;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setHeaderColumnSpacerLeft( string newHeaderColumnSpacerLeft ){
		
	headerColumnSpacerLeft = newHeaderColumnSpacerLeft;
	
	if( headerColumnSpacerLeft.size() > 0 )
		hasExternalHeaderSpacerLeft = true;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setHeaderColumnSpacerRight( string newHeaderColumnSpacerRight ){
		
	headerColumnSpacerRight = newHeaderColumnSpacerRight;
	
	if( headerColumnSpacerRight.size() > 0 )
		hasExternalHeaderSpacerRight = true;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDividerColumnSpacer( string newDividerColumnSpacer ){
		
	dividerColumnSpacer = newDividerColumnSpacer;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDividerColumnSpacerLeft( string newDividerColumnSpacerLeft ){
		
	dividerColumnSpacerLeft = newDividerColumnSpacerLeft;
	
	if( dividerColumnSpacerLeft.size() > 0 )
		hasExternalDividerSpacerLeft = true;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDividerColumnSpacerRight( string newDividerColumnSpacerRight ){
		
	dividerColumnSpacerRight = newDividerColumnSpacerRight;
	
	if( dividerColumnSpacerRight.size() > 0 )
		hasExternalDividerSpacerRight = true;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDataColumnSpacer( string newDataColumnSpacer ){
		
	dataColumnSpacer = newDataColumnSpacer;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDataColumnSpacerLeft( string newDataColumnSpacerLeft ){
		
	dataColumnSpacerLeft = newDataColumnSpacerLeft;
	
	if( dataColumnSpacerLeft.size() > 0 )
		hasExternalDataSpacerLeft = true;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDataColumnSpacerRight( string newDataColumnSpacerRight ){
		
	dataColumnSpacerRight = newDataColumnSpacerRight;
	
	if( dataColumnSpacerRight.size() > 0 )
		hasExternalDataSpacerRight = true;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}
	
void TableFormatter:: setColumnHeaders( vector<string> newColumnHeaders ){
		
	columnHeaders = newColumnHeaders;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDivider( char newDividerChar ){
		
	dividerChar = newDividerChar;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that a new value
	// has been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}
	
void TableFormatter:: setColumnData( vector< map<int, string> > newColumnData ){
		
	columnData = newColumnData;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that new value(s)
	// have been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}
	
void TableFormatter:: setDefaultFieldValues( map<int, string> newDefaultFieldValues ){
		
	defaultFieldValues = newDefaultFieldValues;
	
	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that new value(s)
	// have been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
		
}

void TableFormatter:: setDefaultFieldValue( string newDefaultFieldValue ){
	
	defaultFieldValue = newDefaultFieldValue;

	// if "formatTable()" was called prior to this method,
	// the old formatting is invalid now that new value(s)
	// have been set ..
	if ( isTableFormatted == true )
		isTableFormatted = false;
	
}


void TableFormatter:: findMaxNumberOfColumns() {
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		if( assertionsOn ) cout << "findMaxNumberOfColumns() start .." << endl << endl;
	
		// there is only 1 row for the "headers", so
		// the max column count is just the size of the data structure
		// holding the "header" fields ..
		maxNumberOfHeaderColumns = columnHeaders.size();
	
		int columnCount = 0;
	
		for(int i=0; i<columnData.size(); i++){
			
			if( assertionsOn ) cout << "findMaxNumberOfColumns() Point A["<<i<<"] .." << endl << endl;
		
			// row "i"..
		
			//cout << "findMaxNumberOfColumns() columnData["<<i<<"].size(): " << columnData[i].size() << endl << endl;

			for(int j=0; j<columnData[i].size(); j++){
				
				if( assertionsOn ) cout << "findMaxNumberOfColumns() Point B["<<i<<"]["<<j<<"] .." << endl << endl;
			
				// column "j" for this row "i" ..
				columnCount++;

			}
		
			if( maxNumberOfDataColumns < columnCount ){
			
				// each row of "columnData" can have a different
				// count of columns (jagged array), so
				// get out the max count of columns for the entire table ..
				maxNumberOfDataColumns = columnCount;
				
			}
		
			// reset this parameter for next iteration (row) ..
			columnCount = 0;
		
		}
	
		// if "maxNumberOfDataColumns" is less than "maxNumberOfHeaderColumns",
		// say because an entire column of data is missing, then
		// in order to print up "default" values in the missing column,
		// just set "maxNumberOfDataColumns" == "maxNumberOfHeaderColumns" ..
		if( maxNumberOfDataColumns < maxNumberOfHeaderColumns ){
		
			maxNumberOfDataColumns = maxNumberOfHeaderColumns;
		
		}
	
	
	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}
	
	assertionsOn = false;
	
} // end "findMaxNumberOfColumns()" ..


bool TableFormatter:: isHeaderEmpty() {
	
	bool isHeaderEmpty = false;
	
	if ( columnHeaders.size() == 0 ) {
		
		isHeaderEmpty = true;
		
		errorString += "\nTable headers are missing.";
		
	}
	
	return isHeaderEmpty;
	
} // end "isHeaderEmpty()" ..


bool TableFormatter:: isDataEmpty() {
	
	bool isDataEmpty = false;
	
	if( columnData.size() == 0 ){
		
		isDataEmpty = true;
		
	} else {
	
		for(int i=0; i<columnData.size(); i++){
			
			// DEBBUGGING ..
			//cout << "isDataEmpty() columnData["<<i<<"].size(): " << columnData[i].size() << endl << endl;

			if ( columnData[i].size() != 0 ){
			
				isDataEmpty = false;
				break;
			
			}
		
		}
	
	}
	
	if ( isDataEmpty == true ) {
		
		errorString += "\nTable data values are missing.";
		
	}
	
	
	return isDataEmpty;
	
	
} // end "isDataEmpty()" ..


void TableFormatter:: populateHeaderSizes() {
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		//cout << "\n";
		
		if ( isHeaderPopulated == false ) {
			
			// only perform this method once, unless
			// the user invokes the "resetHeaders()" method,
			// which sets isHeaderPopulated == true ..
		
			if( assertionsOn ) cout << "populateHeaderSizes() start .." << endl << endl;
			if( assertionsOn ) cout << "populateHeaderSizes() maxNumberOfHeaderColumns: " << maxNumberOfHeaderColumns << endl << endl;
	
			for(int i=0; i<maxNumberOfHeaderColumns; i++){
			
				if( assertionsOn ) cout << "populateHeaderSizes() Point A["<<i<<"] .." << endl << endl;
		
				if ( i < columnHeaders.size() ) {
				
					if( assertionsOn ) cout << "populateHeaderSizes() Point B["<<i<<"] .." << endl << endl;
					if( assertionsOn ) cout << "populateHeaderSizes() ( i("<<i<<") < columnHeaders.size()("<<columnHeaders.size()<<") ): " << ( i < columnHeaders.size() ) << endl << endl;
					if( assertionsOn ) cout << "populateHeaderSizes() columnHeaders[i("<<i<<")].size(): " << columnHeaders[i].size() << endl << endl;
					if( assertionsOn ) cout << "populateHeaderSizes() columnHeaders[i("<<i<<")]: " << columnHeaders[i] << endl << endl;
			
					headerSizes.push_back( columnHeaders[i].size() );
			
				} else {
				
					if( assertionsOn ) cout << "populateHeaderSizes() Point C["<<i<<"] .." << endl << endl;
			
					// deal with "jagged array" where the "header" row has fewer columns
					// than the max number of columns for this table ..
					headerSizes.push_back( 0 );
			
				}
				
				// track "headerSizes" now that it is populated ..
				if ( isHeaderPopulated == false )
					isHeaderPopulated = true;
		
			} // end "for()" ..
	
	
		} // end "if ( isHeaderPopulated == false )" ..
	
	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}
	
	assertionsOn = false;
	
} // end "populateHeaderSizes()" ..


void TableFormatter:: populateDataSizes() {
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		if ( isDataPopulated == false ) {
	
			if( assertionsOn ) cout << "populateDataSizes() start .." << endl << endl;
	
			map<int, string>::iterator it_data;
	
			map<int, string>::iterator it_default;
	
			vector<int>* dataKeys;
	
			vector<int> defaultKeys;
	
			int dataKeysCounter = 0;
	
			int numberOfDataKeys = 0;
	
			int dataSizesCounter = -1;
	
			bool defaultKeyFound = false;
	
			for(it_default=defaultFieldValues.begin(); it_default!=defaultFieldValues.end(); it_default++){
		
				// get out all the keys for the data for this row ..
				// (number of keys may be less than "maxNumberOfColumns",
				//  in which case the subsequent code will know to use 
				//  a default data value for display) ..
			
				if( assertionsOn ) cout << "populateHeaderSizes() Point A .." << endl << endl;
			
				if( ( (*it_default).second ).size() > 0 ){
			
					defaultKeys.push_back( (*it_default).first );
		
				}
		
			} // end "for()" ..
		
			if( assertionsOn ) cout << "populateHeaderSizes() Point B .." << endl << endl;
	
			for(int i=0; i<columnData.size(); i++){
		
				// DEBBUGGING ..
				//cout << "I: populateDataSizes() columnData["<<i<<"].size(): " << columnData[i].size() << endl << endl;
				//cout << "Point A3_B1["<<i<<"].." << endl << endl;
			
				if( assertionsOn ) cout << "populateHeaderSizes() Point C["<<i<<"] .." << endl << endl;

				dataKeys = new vector<int>();

				for(it_data=columnData[i].begin(); it_data!=columnData[i].end(); it_data++){
		
					// DEBBUGGING ..
					//cout << "Point A3_B1A["<<i<<"] dataKeys.." << endl << endl;
				
					if( assertionsOn ) cout << "populateHeaderSizes() Point D["<<i<<"] .." << endl << endl;
		
					// get out all the keys for the data for this row ..
					// (number of keys may be less than "maxNumberOfDataColumns",
					//  in which case the subsequent "print" code will know to use 
					//  a default data value for display) ..
					dataKeys->push_back( (*it_data).first );
		
				} // end "for()" ..
		
				// DEBBUGGING ..
				//cout << "Point A3_B2["<<i<<"].." << endl << endl;
		
				numberOfDataKeys = dataKeys->size();
		
				// DEBBUGGING ..
				//for(int i=0; i<dataKeys->size(); i++){
					//cout << "populateDataSizes() ( *dataKeys )["<<i<<"]: " << ( *dataKeys )[i] << endl << endl;	
				//}
		
				// prepare to track sizes of data values of current (non-empty) row ..
				if ( columnData[i].size() > 0 ) {
			
					dataSizes.push_back( ( *new vector<int>() ) );
			
					dataSizesCounter++;
			
				}
		
				// DEBBUGGING ..
				//cout << "Point A3_B3["<<i<<"].." << endl << endl;
			
				// rows ..
		
				for(int j=0; j<maxNumberOfDataColumns; j++){
				
					if( assertionsOn ) cout << "populateHeaderSizes() Point E["<<i<<"]["<<j<<"] .." << endl << endl;
			
					// columns of rows ..
			
					// DEBBUGGING ..
					//cout << "Point A3_B4["<<i<<"]["<<j<<"].." << endl << endl;
					//cout << "populateDataSizes() dataKeyCounter: " << dataKeyCounter << endl << endl;
					//cout << "0: populateDataSizes() ( ( *dataKeys )[ dataKeyCounter("<<dataKeysCounter<<") ]("<<( *dataKeys )[ dataKeysCounter ]<<") == j("<<j<<") ): " << ( ( *dataKeys )[ dataKeysCounter ] == j ) << endl << endl;
			
					if ( ( dataKeys->size() > 0 ) && 
						 ( numberOfDataKeys > dataKeysCounter ) &&
					 	 ( ( *dataKeys )[ dataKeysCounter ] == j ) ) {
				 	
				 		// DEBBUGGING ..
						//cout << "Point A3_B5["<<i<<"]["<<j<<"].." << endl << endl;
						//cout << "dataSizesCounter: " << dataSizesCounter << endl << endl;
						//cout << "columnData["<<i<<"]["<<j<<"].size(): " << columnData[i][j].size() << endl << endl;
						//cout << "columnData["<<i<<"]["<<j<<"]: " << columnData[i][j] << endl << endl;
				 	
						// when "dataKeys.size()" is always greater than 0, and
						// "dataKeys" corresponds with column number ..
				
						dataSizes[ dataSizesCounter ].push_back( columnData[i][j].size() );
				
						dataKeysCounter++;
				
					} else if ( columnData[i].size() > 0 ) {
				
						// DEBBUGGING ..
						//cout << "Point A3_B6["<<i<<"]["<<j<<"].." << endl << endl;
					
						// this row has at least 1 non-empty fields, but
						// this column fields is empty ..
					
						// deal with "jagged array" where this row has fewer columns
						// than the max number of columns for this table ..
						 	
						for(int k=0; k<defaultKeys.size(); k++){
						
							if( defaultKeys[ k ] == j ){
							
								// if a default key corresponds to this column,
								// use the default value for this column fields ..
								defaultKeyFound = true;
								break;
							
							}
						
						} // end "for()" ..
					
						if( defaultKeyFound == true ){
						
							// use the size of the "default" value that is printed
							// when the data fields is empty and,
							dataSizes[ dataSizesCounter ].push_back( defaultFieldValues[ j ].size() );

							// reset this parameter for the next iteration (column) ..
							defaultKeyFound = false;
					
						} else {
					
							// DEBBUGGING ..
							//cout << "Point A3_B8["<<i<<"]["<<j<<"].." << endl << endl;
					
							// there is no "default" value for this empty data fields,
							// so "TableFormatter" will place the "-" character in this cell,
							// so the size of this char is "1" ..
							dataSizes[ dataSizesCounter ].push_back( defaultFieldValue.size() );
					
						}
				
					} // end "if ( columnData[i].size() > 0 )" ..
			
					// track "dataSizes" now that it is populated ..
					if ( isDataPopulated == false )
						isDataPopulated = true;
			
				} // end "for()" ..
		
				// DEBBUGGING ..
				//cout << "Point A3_B9["<<i<<"].." << endl << endl;
		
				// reset these parameters for the next iteration ..
				dataKeysCounter = 0;
				numberOfDataKeys = 0;
				delete dataKeys;
		
			} // end "for()" ..
	
			// DEBBUGGING ..
			//cout << "Point A3_B10.." << endl << endl;
			//cout << "I: populateDataSizes() columnData[0].size(): " << columnData[0].size() << endl << endl;
			//cout << "I: populateDataSizes() columnData[1].size(): " << columnData[1].size() << endl << endl;
	
			// reset this parameter for the invocation of this method ..
			defaultKeys.clear();
	
		}
	
	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}
	
	assertionsOn = false;
	
} // end "populateDataSizes()" ..


void TableFormatter:: populateMaxColumnSizes() {
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		if( assertionsOn ) cout << "populateMaxColumnSizes() start .." << endl << endl;
	
		string header = "";
	
		int numberOfRows = dataSizes.size();
	
		int maxColumnSize = 0;
	
		for(int j=0; j<maxNumberOfDataColumns; j++){
			
			if( assertionsOn ) cout << "populateMaxColumnSizes() Point B["<<j<<"] .." << endl << endl;
		
			// columns "j" ..
		
			if( ( maxNumberOfHeaderColumns > j ) && 
		   	    ( headerSizes[j] > maxColumnSize ) ) {
				
				// only use this "j"th "header" column size if it exists, and
				// only use this size if it is greater than the existing max size ..
				maxColumnSize = headerSizes[j];
				
			}
		
			for(int i=0; i<numberOfRows; i++){
				
				if( assertionsOn ) cout << "populateMaxColumnSizes() Point C["<<j<<"]["<<i<<"] .." << endl << endl;
			
				// rows "i" for each column "j" ..
			
				if( dataSizes[i][j] > maxColumnSize ) {
				
					maxColumnSize = dataSizes[i][j];
				
				}
			
			} // end "for()" ..
		
		
			maxColumnSizes.push_back( maxColumnSize );
		
			// reset this parameter for the next iteration (column) ..
			maxColumnSize = 0;
		
		
		} // end "for()" ..


	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}	

	assertionsOn = false;
	
} // end "populateMaxColumnSizes()" ..


void TableFormatter:: populateSizes() {
	
	//assertionsOn = true;
	assertionsOn = false;
	
	if( assertionsOn ) cout << "populateSizes() start .." << endl << endl;
		
 	// get sizes of all header fields ..
	populateHeaderSizes();

	// get sizes of all the data fields ..
	populateDataSizes();

	// get the max width for each column,
	// based on both the header for the column and
	// on every data fields in the column ..
	populateMaxColumnSizes();

	assertionsOn = false;
	
} // end "TableFormatter:: populateSizes()" ..


void TableFormatter:: printHeaders(){
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		if( assertionsOn ) cout << "printHeaders() start .." << endl << endl;
	
		//cout << "maxNumberOfColumns: " << maxNumberOfColumns << endl << endl;
	
		//cout << "columnHeaders.size(): " << columnHeaders.size() << endl << endl;

		for(int i=0; i<columnHeaders.size(); i++){
			
			if( assertionsOn ) cout << "printHeaders() Point A["<<i<<"] .." << endl << endl;
		
			// only put a spacer on the start of the line if user requests this ..
			if ( hasExternalHeaderSpacerLeft == true ){
				
				// space between columns ..
				if ( i == 0 )
					cout << headerColumnSpacerLeft;
				
			}
		
			int columnWidth = -1;

			if( maxColumnSizes[i] > headerSizes[i] ) {
					
				columnWidth = maxColumnSizes[i];
					
			} else {

				columnWidth = headerSizes[i];
					
			}
			
			// "%-*s" : "-" is left justify, "*" is pad "paddingWidth" number of spaces,
			//          "s" is insert string ..
			printf("%-*s", columnWidth, ( (char*) columnHeaders[i].c_str() ) );
		
			// space between columns ..
			if( i < ( maxNumberOfHeaderColumns - 1 ) )
				//cout << "  ";
				cout << headerColumnSpacer;
				
			// only put a spacer on the end of the line if user requests this ..
			if ( hasExternalHeaderSpacerRight == true ){
				
				// space between columns ..
				if ( i == ( maxNumberOfHeaderColumns - 1 ) )
					cout << headerColumnSpacerRight;
				
			}
		
		}

		// end of the "header" row ..
		cout << endl;
		
		
	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}
	
	assertionsOn = false;

} // end "printHeaders()" ..


void TableFormatter:: printDivider(){
	
	string dividerString;
	
	dividerString += dividerChar;
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		if( assertionsOn ) cout << "printDivider() start .." << endl << endl;
	
		// print the "divder" bar for this table ..
	
		int maxNumberOfColumns = -1;
	
		// use the larger of either "header" or "data" for "maxNumberOfColumns" ..
		if ( maxNumberOfHeaderColumns < maxNumberOfDataColumns ) {
		
			maxNumberOfColumns = maxNumberOfDataColumns;
		
		} else {
		
			maxNumberOfColumns = maxNumberOfHeaderColumns;
		
		}

		for(int i=0; i<maxNumberOfColumns; i++){
			
			if( assertionsOn ) cout << "printDivider() Point A["<<i<<"] .." << endl << endl;

			// only put a spacer on the start of the line if user requests this ..
			if ( hasExternalDividerSpacerLeft == true ){
				
				// space between columns ..
				if ( i == 0 )
					cout << dividerColumnSpacerLeft;
				
			}

			for(int j=0; j<maxColumnSizes[i]; j++){
				
				if( assertionsOn ) cout << "printDivider() Point B["<<i<<"]["<<j<<"] .." << endl << endl;
				
				//cout << "=";
				cout << dividerString;
				
			}
			
			if( i < ( maxNumberOfColumns - 1 ) )
				//cout << "||";
				cout << dividerColumnSpacer;
		
			// only put a spacer on the end of the line if user requests this ..
			if ( hasExternalDividerSpacerRight == true ){
									
				// space between columns ..
				if ( i == ( maxNumberOfColumns - 1 ) )
					cout << dividerColumnSpacerRight;

			}
		
		}
		

	
		cout << endl;


	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}
	
	assertionsOn = false;
	
} // end "printDivider()" ..


void TableFormatter:: printData(){
	
	//assertionsOn = true;
	assertionsOn = false;
	
	try {
		
		if( assertionsOn ) cout << "printData() start .." << endl << endl;
	
		// print the "divider" bar for this table ..
	
		int numberOfRows = columnData.size();
	
		int dataKeysCounter = 0;
	
		int numberOfDataKeys = 0;
	
		bool defaultKeyFound = false;
	
		map<int, string>::iterator it_data;
	
		map<int, string>::iterator it_default;
	
		vector<int>* dataKeys;
	
		vector<int> defaultKeys;
	
		// DEBBUGGING ..
		//cout << "maxNumberOfDataColumns: " << maxNumberOfDataColumns << endl << endl;
		//cout << "      numberOfRows: " << numberOfRows << endl << endl;
	
		string printString = "";
	
		// DEBBUGGING ..
		//cout << "defaultFieldValues.size(): " << defaultFieldValues.size() << endl << endl;
	
		for(it_default=defaultFieldValues.begin(); it_default!=defaultFieldValues.end(); it_default++){
		
			// get out all the keys for the data for this row ..
			// (number of keys may be less than "maxNumberOfColumns",
			//  in which case the subsequent code will know to use 
			//  a default data value for display) ..
			
			if( assertionsOn ) cout << "printData() Point A .." << endl << endl;
		
			if( ( (*it_default).second ).size() > 0 ){
			
				defaultKeys.push_back( (*it_default).first );
			
			}
		
			// DEBBUGGING ..
			//cout << "  defaultKeys: " << (*it_default).first << endl << endl;
			//cout << "defaultValues: " << (*it_default).second << endl << endl;
			//cout << "defaultFieldValues["<< (*it_default).first <<"]: " << defaultFieldValues[ (*it_default).first ] << endl << endl;
		
		} // end "for()" ..
	
		if( assertionsOn ) cout << "printData() Point B .." << endl << endl;
	
		for(int i=0; i<numberOfRows; i++){
			
			if( assertionsOn ) cout << "printData() Point C["<<i<<"] .." << endl << endl;
		
			//cout << "printData() columnData["<<i<<"].size(): " << columnData[i].size() << endl << endl;
		
			dataKeys = new vector<int>();
		
			for(it_data=columnData[i].begin(); it_data!=columnData[i].end(); it_data++){
		
				// get out all the keys for the data for this row ..
				// (number of keys may be less than "maxNumberOfDataColumns",
				//  in which case the subsequent code will know to use 
				//  a default data value for display) ..
				dataKeys->push_back( (*it_data).first );

			} // end "for()" ..
		
			numberOfDataKeys = dataKeys->size();
		
			// DEBBUGGING ..
			//for(int j=0; j<dataKeys->size(); j++){
				//cout << "( *dataKeys )[i("<<i<<")][j("<<j<<")]: " << ( *dataKeys )[j] << endl << endl;
			//}

			for(int j=0; j<maxNumberOfDataColumns; j++){
				
				if( assertionsOn ) cout << "printData() Point D["<<i<<"]["<<j<<"] .." << endl << endl;
			
				// only put a spacer on the start of the line if user requests this ..
				if ( hasExternalDataSpacerLeft == true ){
				
					// space between columns ..
					if ( j == 0 )
						cout << dataColumnSpacerLeft;
				
				}
			
			
				// DEBBUGGING ..
				//cout << "( *dataKeys )[i("<<i<<")].size(): " << ( *dataKeys ).size() << endl << endl;
				//cout << "0: ( ( *dataKeys )[ dataKeysCounter("<<dataKeysCounter<<") ]("<<( *dataKeys )[ dataKeysCounter ]<<") == j("<<j<<") ): " << ( ( *dataKeys )[ dataKeysCounter ] == j ) << endl << endl;
				//cout << "0: ( numberOfDataKeys("<<numberOfDataKeys<<") > dataKeysCounter("<<dataKeysCounter<<") ): " << ( numberOfDataKeys > dataKeysCounter ) << endl << endl;


				if ( ( dataKeys->size() > 0 ) && 
					 ( numberOfDataKeys > dataKeysCounter ) &&
				 	 ( ( *dataKeys )[ dataKeysCounter ] == j ) ) {
				 	
					// when "dataKeys" is always greater than 0 / j, and
					// "dataKeys" corresponds with column number ..
			
					printString = columnData[i][j];
				
					dataKeysCounter++;
				
					// DEBBUGGING ..
					//cout << "I: printString[i("<<i<<")][j("<<j<<")]: \"" << printString << "\"" << endl << endl;
					
				} else if ( columnData[i].size() > 0 ) {
				
					// this row has at least 1 non-empty fields, but
					// this column fields is empty ..
					 	
					for(int k=0; k<defaultKeys.size(); k++){
						
						if( defaultKeys[ k ] == j ){
							
							// if a default key corresponds to this column,
							// use the default value for this column fields ..
							defaultKeyFound = true;
							break;
							
						}
						
					} // end "for()" ..
					
					if( defaultKeyFound == true ){
						
						// when "defaultKeys.size()" is always greater than 0, and
						// "defaultKeys" corresponds with column number ..
					
						printString = defaultFieldValues[j];
					
						// reset this parameter for the next iteration (column) ..
						defaultKeyFound = false;
				
						// DEBBUGGING ..
						//cout << "II: printString[i("<<i<<")][j("<<j<<")]: \"" << printString << "\"" << endl << endl;
					
					
					} else {
					
						// this is the default output if no other output is specified ..
						//printString = "*";
						printString = defaultFieldValue;
				
						// DEBBUGGING ..
						//cout << "III: printString[i("<<i<<")][j("<<j<<")]: \"" << printString << "\"" << endl << endl;
					
					}
				
				} // end "if ( columnData[i].size() > 0 )" ..
			
			
				if ( columnData[i].size() > 0 ) {
				
					// this row has at least 1 non-empty fields, so
					// go ahead and print "data" or "default" value ..
			
					// "%-*s" : "-" is left justify, "*" is pad "maxColumnSizes[j]" number of spaces,
					//          "s" is insert string ..
					printf("%-*s", maxColumnSizes[j], ( (char*) printString.c_str() ) );
			
			
					// space between columns ..
					if( j < ( maxNumberOfDataColumns - 1 ) )
						//cout << "  ";
						cout << dataColumnSpacer;
						
					// only put a spacer on the end of the line if user requests this ..
					if ( hasExternalDataSpacerRight == true ){
				
						// space between columns ..
						if ( j == ( maxNumberOfDataColumns - 1 ) )
							cout << dataColumnSpacerRight;
				
					}
				
					// reset this parameter for the next iteration (column fields) ..
					printString.clear();
				
				}
			
			} // end "for()" ..
		
			if ( columnData[i].size() > 0 ) {
		
				// (only do this if the row is non-empty)
				// end of the row ..
				cout << endl;
			
			}
		
			// reset this parameter for the next iteration (row) ..
			dataKeysCounter = 0;
			numberOfDataKeys = 0;
			delete dataKeys;
		
		} // end "for()" ..
	
		// reset this parameter for the next time this method is called ..
		defaultKeys.clear();


	} catch(...) {
		
		errorString += "\nAn error occurred.";
		
		errorFlag = true;
		
	}

	assertionsOn = false;
	
} // end "printData()" ..


void TableFormatter:: formatTable() {
	
	// initialize this parameter ..
	isTableFormatted = false;
	
	// if there are at least some "header" values, 
	// go ahead and format the table ..
	//if ( isHeaderEmpty() == false ) {
	
	findMaxNumberOfColumns();
		
	populateSizes();
		
	if ( errorFlag == false )
		isTableFormatted = true;
	
	
} // end "formatTable()" ..


void TableFormatter:: printTable() {
	
	//assertionsOn = true;
	assertionsOn = false;
	
	if( assertionsOn ) cout << "printTable() Point A.." << endl << endl;
	
	if ( isTableFormatted == true ) {
		
		// only proceed if "formatTable()" was called and
		// performed successfully ..
		
		if( assertionsOn ) cout << "printTable() Point B.." << endl << endl;
		
		if ( isHeaderEmpty() == false ) {
			
			if( assertionsOn ) cout << "printTable() Point C.." << endl << endl;
			
			// if there are at least some "header" values, 
			// go ahead and print the "header" and "divider" ..
		
			printHeaders();
			
			if( assertionsOn ) cout << "printTable() Point D.." << endl << endl;
	
			printDivider();
			
			if( assertionsOn ) cout << "printTable() Point E.." << endl << endl;
		
		}


		if ( isDataEmpty() == false ) {
			
			if( assertionsOn ) cout << "printTable() Point F.." << endl << endl;
			
			// if there are at least some "data" values, 
			// go ahead and print the "data" ..
		
			printData();
		
		}

		if( assertionsOn ) cout << "printTable() Point H.." << endl << endl;

		// DONT DO THIS HERE,
		// instead let the user do this if desired to reuse this "tableFormatter" ..
		// reset parameters for next use of "tableFormatter" ..
		// resetValues();
		
		
	} // end "if ( isTableFormatted == true )" ..
	
	assertionsOn = false;

} // end "printDatabaseTable()" ..


void TableFormatter:: printErrorString() {
	
	if( errorString.size() > 0 ){
		
		cout << errorString << endl;
		
	}
	
} // end "printErrorString()" ..


void TableFormatter:: test( TableFormatter tableFormatter ){


	/*
	 * simplified invocation of methods, 
	 * interface version #1 ..
	 */
	
	// COLUMN TITLES:
	// 	add titles for the columns ..
	// 	if you add more title columns than there are data columns,
	// 		default values will fill the empty data columns ..
	// 	if you add fewer title columns than there are data columns,
	// 		the empty title columns will remain empty ..
	// 	title columns are FIFO (first input, first output) ..
	tableFormatter.addColumnHeader( "buffer #" );
	
	tableFormatter.addColumnHeader( "file / table" );
	
	tableFormatter.addColumnHeader( "block #" );
	
	// OPTIONAL:
	// 	add default values for specific data columns (0, 1, 2, etc ..) ..
	// 	if you add more default values than there are data columns,
	// 		extra default values will be ignored ..
	// 	if you add fewer default values than there are data columns,
	// 		"tableFormatter" will use its own "default value" ..
	tableFormatter.addDefaultValue( 0, "n/a" );
	
	tableFormatter.addDefaultValue( 1, "empty" );
	
	tableFormatter.addDefaultValue( 2, "none" );
	
	
	// COLUMN DATA:
	//	data values are assigned to a specific column (0, 1, 2 etc .. ) ..
	// 		unassigned columns will be filled with default values ..
	// 	START data row #1 ..
	tableFormatter.addColumnData( 0, "0" );
	
	tableFormatter.addColumnData( 1, "abc" );
	
	tableFormatter.addColumnData( 2, "-1" );
	
	// 	if using "addColumnData()", must follow the end of a data row with "endDataRow()"
	// 		in order to insert a "row data structure" into the collection that holds them all ..
	//	END data row #1 ..
	tableFormatter.endDataRow();
	
	
	// START data row #2 ..
	tableFormatter.addColumnData( 0, "1" );
	
	tableFormatter.addColumnData( 1, "xyz" );
	
	tableFormatter.addColumnData( 2, "5" );
	
	// END data row #2 ..
	tableFormatter.endDataRow();
	
	
	// OPTIONAL: user defines "default value" for use in empty data value spots when either,
	// 1) the column does not have a specific "default value" specified for it
	//    (i.e.: 0 & 1 assigned, but 2 commented out / not assigned), or 
	// 2) 
	tableFormatter.setDefaultFieldValue( "E" );
	
	//cout << "Point A.." << endl << endl;
	
	// REQUIRED:
	//	Use the data that was input via methods above to 
	//  setup the format of the table ..
	tableFormatter.formatTable();
	
	//cout << "Point B.." << endl << endl;
	
	// REQUIRED:
	//	Print the table so long as
	//	1) data was input via methods ..
	//	2) "formatTable()" was invoked ..
	tableFormatter.printTable();
	
	// need space btw tables ..
	cout << endl << endl;
	
	// OPTIONAL:
	// clears this instance of "tableFormatter" whenever you wish to reuse 
	// this entire instance, but for a different table (new header, data, etc) ..
	//tableFormatter.resetValues();
	
	// OPTIONAL:
	// clears the "columnHeaders" data structure for this instance of "tableFormatter" 
	// whenever you wish to replace the current values with all new values ..
	tableFormatter.resetHeaders();
	
	tableFormatter.addColumnHeader( "#1" );
	
	tableFormatter.addColumnHeader( "#2" );
	
	tableFormatter.addColumnHeader( "#3" );
	
	// middle, left, right header-column spacers ..
	tableFormatter.setHeaderColumnSpacer( "][" );
	tableFormatter.setHeaderColumnSpacerLeft( "[" );
	tableFormatter.setHeaderColumnSpacerRight( "]" );
	
	// character used in the divider separating "header" from "data" ..
	tableFormatter.setDivider( '*' );
	
	// middle, left, right divider-column spacers ..
	tableFormatter.setDividerColumnSpacer( "][" );
	tableFormatter.setDividerColumnSpacerLeft( "[" );
	tableFormatter.setDividerColumnSpacerRight( "]" );
	
	// middle, left, right data-column spacers ..
	tableFormatter.setDataColumnSpacer( "||" );
	tableFormatter.setDataColumnSpacerLeft( "|" );
	tableFormatter.setDataColumnSpacerRight( "|" );
	
	tableFormatter.formatTable();
	
	tableFormatter.printTable();
	
	
	// need space btw tables ..
	cout << endl << endl;
	
	tableFormatter.resetData();
	
	// START data row #1 ..
	tableFormatter.addColumnData( 0, "1" );
	
	tableFormatter.addColumnData( 1, "xyz" );
	
	tableFormatter.addColumnData( 2, "5" );
	
	// END data row #1 ..
	tableFormatter.endDataRow();
	
	// START data row #2 ..
	tableFormatter.addColumnData( 0, "2" );
	
	//tableFormatter.addColumnData( 1, "abc" );
	
	//tableFormatter.addColumnData( 2, "17" );
	
	// END data row #2 ..
	tableFormatter.endDataRow();
	
	// START data row #3 ..
	//tableFormatter.addColumnData( 0, "2" );
	
	tableFormatter.addColumnData( 1, "7y4" );
	
	tableFormatter.addColumnData( 2, "20" );
	
	// END data row #3 ..
	tableFormatter.endDataRow();
	
	
	tableFormatter.resetHeaders();
	
	tableFormatter.addColumnHeader( "firstCol" );
	
	tableFormatter.addColumnHeader( "secondColumn" );
	
	tableFormatter.addColumnHeader( "3rdCol" );
	
	// middle, left, right header-column spacers ..
	tableFormatter.setHeaderColumnSpacer( "||" );
	tableFormatter.setHeaderColumnSpacerLeft( "|" );
	tableFormatter.setHeaderColumnSpacerRight( "|" );
	
	// character used in the divider separating "header" from "data" ..
	tableFormatter.setDivider( '-' );
	
	// middle, left, right divider-column spacers ..
	tableFormatter.setDividerColumnSpacer( "-" );
	tableFormatter.setDividerColumnSpacerLeft( "|" );
	tableFormatter.setDividerColumnSpacerRight( "|" );
	
	// middle, left, right data-column spacers ..
	tableFormatter.setDataColumnSpacer( "|" );
	tableFormatter.setDataColumnSpacerLeft( "|" );
	tableFormatter.setDataColumnSpacerRight( "|" );
	
	tableFormatter.formatTable();
	
	tableFormatter.printTable();
	
	
	// need space btw tables ..
	cout << endl << endl;
	
	
	// OPTIONAL:
	// clears the "columnData" data structure for this instance of "tableFormatter" 
	// whenever you wish to replace the current values with all new values ..
	tableFormatter.resetData();

	// START data row #1 ..
	tableFormatter.addColumnData( 0, "2" );
	
	tableFormatter.addColumnData( 1, "QAD" );
	
	tableFormatter.addColumnData( 2, "435" );
	
	// END data row #1 ..
	tableFormatter.endDataRow();
	
	// OPTIONAL:
	// clears the middle, left, right headerColumnSpacers ..
	tableFormatter.resetHeaderSpacers();
	
	// OPTIONAL:
	// clears the middle, left, right dividerColumnSpacers ..
	tableFormatter.resetDividerSpacers();
	
	// OPTIONAL:
	// clears the middle, left, right dataColumnSpacers ..
	tableFormatter.resetDataSpacers();
	
	
	tableFormatter.formatTable();
	
	tableFormatter.printTable();
	

	/*
	 * cumbersome invocation of methods, 
	 * interface version #2 ..
	 */

/*
	string bpNumberHeader = "buffer #";
				
	string fileHeader = "file / table";
				
	string pageIDHeader = "block #";
	
	vector<string> columnHeaders;
	
	columnHeaders.push_back( bpNumberHeader );
	
	columnHeaders.push_back( fileHeader );
	
	columnHeaders.push_back( pageIDHeader );
	
	tableFormatter.setColumnHeaders( columnHeaders );
	
	
	vector< map<int, string> > columnData;
	
	map<int, string>* columnDataRow = new map<int, string>();
	
	columnDataRow->insert( pair<int,string>( 0, "0" ) );
	
	columnDataRow->insert( pair<int,string>( 1, "abc" ) );
	
	columnDataRow->insert( pair<int,string>( 2, "-1" ) );
	
	columnData.push_back( ( *columnDataRow ) );
	
	
	delete columnDataRow;
	
	columnDataRow = new map<int, string>();
	
	columnDataRow->insert( pair<int,string>( 0, "1" ) );
	
	columnDataRow->insert( pair<int,string>( 1, "xyz" ) );
	
	columnDataRow->insert( pair<int,string>( 2, "5" ) );
	
	columnData.push_back( ( *columnDataRow ) );
	
	delete columnDataRow;
	
	tableFormatter.setColumnData( columnData );
	
	
	map<int, string> defaultFieldValues;
	
	defaultFieldValues.insert( pair<int,string>( 0, "n/a" ) );
	
	defaultFieldValues.insert( pair<int,string>( 1, "empty" ) );
	
	defaultFieldValues.insert( pair<int,string>( 2, "none" ) );
	
	//cout << "defaultFieldValues.size(): " << defaultFieldValues.size() << endl << endl;
	
	tableFormatter.setDefaultFieldValues( defaultFieldValues );
	
	
	tableFormatter.setDefaultFieldValue( "E" );
	
	//cout << "Point A.." << endl << endl;
	
	tableFormatter.formatTable();
	
	//cout << "Point B.." << endl << endl;
	
	tableFormatter.printDatabaseTable();
	
	
	/*
	 * end of test ..
	 */
	
	
} // end "test()" ..

