#include "Timer.h"

Timer:: Timer() {
	
	timerStatus = false;
	
}

void Timer:: setTimerOn(){
	
	timerStatus = true;
	
}


void Timer:: setTimerOff(){
	
	timerStatus = false;
	
}


bool Timer:: getTimerStatus(){
	
	return timerStatus;
	
}


void Timer:: startTimer(){
	
	// "clock()" returns "long" number equivalent to the 
	// number of milliseconds since the application started running ..
	
	// "CLOCKS_PER_SEC" = 1000 ..
	
	// "(double) clock()" is performed to avoid truncation during 
	// division of "long" / "int" ..
	
	if ( getTimerStatus() == true ) {
				
		startTime = ( (double) clock() / CLOCKS_PER_SEC );		
				
	}
	
} // end "startTimer()" ..


void Timer:: stopTimer(){

	// "clock()" returns "long" number equivalent to the 
	// number of milliseconds since the application started running ..
	
	// "CLOCKS_PER_SEC" = 1000 ..
	
	// "(double) clock()" is performed to avoid truncation during 
	// division of "long" / "int" ..
	
	if ( getTimerStatus() == true ) {
	
		endTime = ( (double) clock() / CLOCKS_PER_SEC );
	
		// result of "timer" feature ..
		cout << endl << endl << "operation took " << getElapsedMilliseconds() << " milliseconds" << endl << endl;	
	
	
		// DEBBUGGING ..
		//cout << "startTime: " << ( startTime * 1000 ) << endl << endl;
		//cout << "endTime: " << ( endTime * 1000 ) << endl << endl;
	
	}
	
} // end "stopTimer()" ..


string Timer:: getElapsedSeconds(){
	
	elapsedTime = ( endTime - startTime );
	
	string elapsedTimeString = doubleToStr( elapsedTime );
	
	char elapsedTimeCharString[ elapsedTimeString.size() ];
	
	sprintf( elapsedTimeCharString, "%.3f", elapsedTime );
	
	return elapsedTimeCharString;
	
} // end "getElapsedSeconds()" ..


string Timer:: getElapsedMilliseconds(){
	
	elapsedTime = ( endTime - startTime );
	
	double elapsedTimeMilliseconds = ( elapsedTime * 1000 );
	
	string elapsedTimeString = doubleToStr( elapsedTime );
	
	char elapsedTimeCharString[ elapsedTimeString.size() ];
	
	sprintf( elapsedTimeCharString, "%.0f", elapsedTimeMilliseconds );
	
	return elapsedTimeCharString;
	
} // end "getElapsedMilliseconds()" ..

